/* drvTS.h */

/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
*     National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
*     Operator of Los Alamos National Laboratory.
* EPICS BASE Versions 3.13.7
* and higher are distributed subject to a Software License Agreement found
* in file LICENSE that is included with this distribution. 
\*************************************************************************/
#ifndef __DRVTS_h__
#define __DRVTS_h__

/**************************************************************************
 *
 *     Author:	Jim Kowalkowski
 *
 ***********************************************************************/

#include "shareLib.h"
#ifdef __cplusplus
extern "C" {
#endif /*__cplusplus*/


/* global functions */
epicsShareFunc long epicsShareAPI
    TSinit(void);
epicsShareFunc long epicsShareAPI
    TSreport(void);
epicsShareFunc void epicsShareAPI
    TSconfigure(int master, int sync_rate_sec, int clock_rate_hz,
	int master_port, int slave_port,
	int millisecond_request_time_out, int type);
epicsShareFunc long epicsShareAPI
    TSsetClockFromUnix(void);
epicsShareFunc long epicsShareAPI
    TSsetSyncReportThreshold(int syncMilliseconds,int syncUnixMilliseconds);
epicsShareFunc void epicsShareAPI TSprintRealTime(void);
epicsShareFunc void epicsShareAPI TSprintTimeStamp(int num);
epicsShareFunc void epicsShareAPI TSprintCurrentTime(void);
epicsShareFunc void epicsShareAPI TSprintUnixTime(void);
epicsShareFunc void epicsShareAPI TSprintMasterTime(void);

/* event system and time clock functions */
struct drvTSops {
    long (*TSregisterEventHandler)(int Card, void(*func)());
    long (*TSregisterErrorHandler)(int Card, void(*func)());
    long (*TSgetTicks)(int Card, unsigned long *Ticks);
    long (*TShaveReceiver)(int Card);
    long (*TSforceSync)(int Card);
    long (*TSgetTime)(struct timespec*);
    long (*TSsyncEvent)();
    long (*TSdirectTime)();
    long (*TSdriverInit)();
    long (*TSuserGet)(int event_number,struct timespec* sp);
};
epicsShareFunc void epicsShareAPI drvTsRegisterDeviceSupport(struct drvTSops *ops);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __DRVTS_h__ */
